<template>
  <div>
    <div id="i18n-underlay-top"></div>
    <div :class="classes">
      <div>
        <h1 class="mb-4">
          Editing: {{ templateName }}
          <TemplateTypeBadge :type="templateType"></TemplateTypeBadge>
        </h1>

        <div>
          <div class="row">
            <div class="col-4">
              <b-form-group label="Reference Language">
                <b-form-select
                  v-model="selectedReference"
                  :options="languageOptions"
                ></b-form-select>
              </b-form-group>
            </div>
            <div class="col-8">
              <b-form-group label="Target Language">
                <b-form-select
                  v-model="selectedTarget"
                  :options="languageOptions"
                ></b-form-select>
              </b-form-group>
            </div>
          </div>
        </div>

        <div class="row">
          <div class="col-4"></div>
          <div class="col-8">
            <b-input
              v-model="textFilter"
              @change="refreshData"
              placeholder="Search (use % as wildcard, press ENTER to submit)"
            ></b-input>

            <div class="mt-2 d-flex">
              <b-form-checkbox v-model="onlyEmpty" switch>
                show only missing translations
              </b-form-checkbox>

              <b-form-checkbox v-model="onlyModified" switch class="ml-4">
                show only modified translations
              </b-form-checkbox>
            </div>
          </div>
        </div>
      </div>

      <div class="d-flex w-100 justify-content-end mt-4">
        <b-select
          v-model="pageSize"
          :options="pageOptions"
          @change="refreshData"
          style="width: 75px"
          class="mr-2"
          size="sm"
        ></b-select>

        <b-pagination
          :total-rows="totalElements"
          :value="currentPage"
          :per-page="pageSize"
          @change="changePage"
          size="sm"
        ></b-pagination>
      </div>

      <div id="i18n-underlay-body">
        <div class="h-100"></div>
      </div>

      <div class="row">
        <div class="col-4 h1 text-uppercase">{{ selectedReference }}</div>
        <div class="col-8 h1 text-uppercase">{{ selectedTarget }}</div>
      </div>

      <div
        v-for="brick in filteredBricks"
        :key="brick.key"
        class="mt-4 striped"
      >
        <div class="row">
          <div class="col font-weight-bold brick-title">
            {{ brick.definition.key }}
          </div>
        </div>
        <div
          :class="{ 'row-color-deleted': brick.definition.deleted }"
          class="row to-stripe"
        >
          <div class="col-4">
            <div class="d-flex justify-content-between">
              <BrickPreview
                :dist="brick.sourceDist"
                :next="brick.sourceNext"
                style="max-width: 80%;"
              >
              </BrickPreview>
              <b-button
                @click="showPreview(brick, 'source')"
                v-if="hasTranslation(brick, 'source')"
                variant="info"
                class="mt-1 mb-1"
              >
                <font-awesome-icon :icon="['fas', 'eye']" />
              </b-button>
            </div>
          </div>
          <div class="col-8">
            <div class="d-flex justify-content-between">
              <BrickPreview
                :dist="brick.targetDist"
                :next="brick.targetNext"
                style="max-width: 80%;"
              >
              </BrickPreview>

              <div class="pt-1 pb-1 text-nowrap">
                <b-button
                  @click="showPreview(brick, 'target')"
                  v-if="hasTranslation(brick, 'target')"
                  variant="info"
                  class="mr-2"
                >
                  <font-awesome-icon :icon="['fas', 'eye']" />
                </b-button>
                <b-button @click="showEdit(brick)" variant="success">
                  <font-awesome-icon :icon="['fas', 'pencil-alt']" />
                </b-button>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="d-flex w-100 justify-content-end mt-4">
        <b-select
          v-model="pageSize"
          :options="pageOptions"
          @change="refreshData"
          style="width: 75px"
          class="mr-2"
          size="sm"
        ></b-select>

        <b-pagination
          :total-rows="totalElements"
          :value="currentPage"
          :per-page="pageSize"
          @change="changePage"
          size="sm"
        ></b-pagination>
      </div>

      <BrickPreviewModal ref="previewModal"></BrickPreviewModal>
      <BrickEditModal ref="editModal" @save="onSave"></BrickEditModal>
    </div>
  </div>
</template>

<script>
import BrickPreviewModal from './brick/BrickPreviewModal';
import BrickEditModal from './brick/BrickTranslationEditModal';
import BrickPreview from './brick/BrickPreview';
import TemplateTypeBadge from './badge/TemplateTypeBadge';

export default {
  components: {
    BrickPreviewModal,
    BrickEditModal,
    BrickPreview,
    TemplateTypeBadge,
  },
  props: {
    initialTarget: {
      type: String,
      default: null,
    },
    apiBaseUrl: {
      type: String,
      default: '',
    },
    classes: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      pageOptions: [50, 100, 200, 500],
      template: { name: this.$route.params.id, type: 'loading' },
      textFilter: '',
      onlyEmpty: false,
      onlyModified: false,
      currentPage: 1,
      pageSize: 50,
      totalElements: 0,
      selectedReference: 'en',
      selectedTarget: 'en',
      bricks: [],
      loaded: false,
      languageOptions: ['en'],
    };
  },
  computed: {
    templateName() {
      return this.template.name;
    },
    templateType() {
      return this.template.type;
    },
    filteredBricks() {
      if (this.loaded !== true) {
        return [];
      }

      return this.bricks;
    },
  },
  watch: {
    selectedTarget() {
      this.refreshData();
    },
    selectedReference() {
      this.refreshData();
    },
    onlyEmpty(val) {
      this.currentPage = 1;
      this.refreshData();
    },
    onlyModified(val) {
      this.currentPage = 1;
      this.refreshData();
    },
  },
  mounted() {
    this._loadTemplate();
  },
  methods: {
    async _loadTemplate() {
      const loader = this.$loading.show();

      this.template = await this.$axios
        .$get(`${this.apiBaseUrl}/translator/template/${this.$route.params.id}`)
        .catch((err) => {
          alert(err);
        });

      this.languageOptions = this.template.enabledLanguages;
      this.selectedReference = this.template.defaultLanguage;

      if (this.initialTarget) {
        this.selectedTarget = this.initialTarget;
      } else {
        this.languageOptions.some((entry) => {
          if (entry !== this.selectedReference) {
            this.selectedTarget = entry;
            return true;
          }
        });
      }

      this._loadData();

      loader.hide();
    },
    changePage(page) {
      this.currentPage = page;

      this.loaded = false;

      this.refreshData();
    },
    async onSave(brick, translationTarget, translatedValue) {
      const loader = this.$loading.show();

      const request = {
        key: brick.definition.key,
        lang: translationTarget,
        template: this.$route.params.id,
        value: translatedValue,
      };

      const result = await this.$axios
        .$patch(`${this.apiBaseUrl}/translator/translation`, request)
        .catch((err) => {
          alert(err);
        });

      this.bricks.some((entry) => {
        if (entry.definition.key === result.key) {
          if (translationTarget === this.selectedReference) {
            entry.sourceNext = result;
          } else if (translationTarget === this.selectedTarget) {
            entry.targetNext = result;
          }

          return true;
        }
      });

      loader.hide();
    },
    refreshData() {
      const loader = this.$loading.show();

      this._loadData();

      loader.hide();
    },
    async _loadData() {
      this.loaded = false;

      const result = await this.$axios
        .$get(
          `${this.apiBaseUrl}/translator/bricktranslation/${
            this.$route.params.id
          }?pageNumber=${this.currentPage - 1}&pageSize=${
            this.pageSize
          }&emptyOnly=${this.onlyEmpty}&modifiedOnly=${
            this.onlyModified
          }&sourceLanguage=${this.selectedReference}&targetLanguage=${
            this.selectedTarget
          }&searchTerm=${encodeURIComponent(this.textFilter)}`
        )
        .catch((err) => {
          alert(err);
        });

      this.bricks = result.content;
      this.totalElements = result.totalElements;

      this.loaded = true;
    },
    showEdit(brick) {
      this.$refs.editModal.show(
        brick,
        this.selectedReference,
        this.selectedTarget
      );
    },
    showPreview(brick, mode) {
      this.$refs.previewModal.show(brick, mode);
    },
    hasTranslation(brick, mode) {
      if (mode === 'source') {
        return !!brick.sourceDist || !!brick.sourceNext;
      }

      return !!brick.targetDist || !!brick.targetNext;
    },
  },
};
</script>

<style lang="scss">
.d-table-cell {
  padding: 0.25rem;
}
</style>
